/*
 * Turbo Cable Utilities
 *
 * Copyright (C) 2004 BLADOX, s.r.o.
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation; either version 2, or (at your option) any
 * later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 */


#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <time.h>
#include <stdarg.h>
#include "modeminit.h"
#include "logging.h"
#include "alarm.h"

#include "cablelib.h"

/*
TODO:
overwrite
if path doesnot exists
error handling
*/

u8 overwrite;
u8 sort;

void help ()
{
  printf ("Usage: [args] inode_in_hex\n");
  printf ("-bx\tbaudrate x (def. 19200)\n");
  printf ("-dx\tdevice x (def. /dev/ttyS1)\n");
  printf ("-h\thelp\n");
  printf ("-v\tverbose\n");
  exit (0);
}

int main (int argc, char **argv)
{
  char cmd[500];
  char answer[1000];
  u8 buf[500];
  u8 t[] = { 0x01, 0x23, 0x45, 0x67 };
  u32 i, j;
  b32 f;
  int result;
  struct stat _st;
  FILE *fs;
  u8 *s_name;
  u8 *d_name;
  int s_size;
  u8 *s_buf;
  int ret;
  int pos;
  int len;
  u8 ext[] = { 0, 0, 0, 0 };
  u8 path[1000] = { '/', '\0' };
  u8 name[1000];
  u16 name_end;
  u16 path_end;

  strcpy (device, "/dev/ttyS1");
  rtscts = 1;
  overwrite = 0;

  do
  {
    result = getopt (argc, argv, "vd:b:h");
    switch (result)
    {
      case 'H':
	rtscts = 0;
	break;
      case 'd':
	strcpy (device, optarg);
	break;
      case 'b':
	set_baudrate (atoi (optarg));
	break;
      case 'v':
	set_verbose ();
	break;
      case 'h':
	help ();
	break;
    }
  }
  while (result > 0);

  if (argc - optind != 1)
    help ();

  sscanf (argv[optind], "%x", &i);
  f = fs_ino_p (i >> 8, i & 0xFF);

  openmodem ();
  setmodemparams ();
  initmodem ();
  printf ("modem initiated\n");

  printf ("Inode: %04X%02X\n", fs_ino_block (f), fs_ino_index (f));
  cable_delete_inode (f);
}
